
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _cur_dig=R5
	.DEF _f=R6
	.DEF _h=R8
	.DEF _z=R10

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_digits_G000:
	.DB  0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7
	.DB  0x8,0x9,0xA,0xB,0xC,0xD,0xE,0xF

_0xA:
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x5,0x0
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x5,0x0
	.DB  0x8,0x0,0x8,0x0,0x5,0x0,0x2,0x0
	.DB  0x5,0x0,0x8,0x0,0x5,0x0,0x2,0x0
	.DB  0x5,0x0,0x8,0x0,0x8,0x0,0x5,0x0
	.DB  0x2,0x0,0x5,0x0,0x8,0x0,0x5,0x0
	.DB  0x2,0x0,0x5,0x0,0x8,0x0,0x8,0x0
	.DB  0x5,0x0,0x2,0x0,0x5,0x0,0x8,0x0
	.DB  0x5,0x0,0x2,0x0,0x5,0x0,0x8,0x0
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x5,0x0
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x5,0x0
	.DB  0x8,0x0
_0x11:
	.DB  0x8,0x0,0x1,0x0,0x2,0x0,0x4,0x0
	.DB  0x8,0x0,0x4,0x0,0x2,0x0,0x1,0x0
	.DB  0x8,0x0,0x8,0x0,0x1,0x0,0x2,0x0
	.DB  0x4,0x0,0x8,0x0,0x4,0x0,0x2,0x0
	.DB  0x1,0x0,0x8,0x0,0x8,0x0,0x1,0x0
	.DB  0x2,0x0,0x4,0x0,0x8,0x0,0x4,0x0
	.DB  0x2,0x0,0x1,0x0,0x8,0x0,0x8,0x0
	.DB  0x1,0x0,0x2,0x0,0x4,0x0,0x8,0x0
	.DB  0x4,0x0,0x2,0x0,0x1,0x0,0x8,0x0
	.DB  0x8,0x0,0x1,0x0,0x2,0x0,0x4,0x0
	.DB  0x8,0x0,0x4,0x0,0x2,0x0,0x1,0x0
	.DB  0x8,0x0
_0x18:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0x0,0x0,0xF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0x0,0x0,0x0,0x0,0xF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0xF,0x0,0x0,0x0
	.DB  0x0,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0xF,0x0,0x0,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0xF,0x0,0x0,0x0
_0x1F:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0xC,0x0
	.DB  0xE,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xE,0x0,0xC,0x0,0x8,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xF,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x1,0x0,0x3,0x0
	.DB  0x7,0x0,0xF,0x0,0x7,0x0,0x3,0x0
	.DB  0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xF,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x0,0x3,0x0,0x7,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0x7,0x0,0x3,0x0,0x1,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xF,0x0
	.DB  0x0,0x0,0x2,0x0,0x7,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0x7,0x0,0x2,0x0,0xF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0xC,0x0
	.DB  0xE,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xE,0x0,0xC,0x0,0x8,0x0,0x0,0x0
	.DB  0x0,0x0,0xF,0x0,0x0,0x0
_0x26:
	.DB  0x8,0x0,0x0,0x0,0xF,0x0,0x8,0x0
	.DB  0xF,0x0,0x0,0x0,0xF,0x0,0x8,0x0
	.DB  0xF,0x0,0x8,0x0,0xF,0x0,0x8,0x0
	.DB  0xF,0x0,0x8,0x0,0x0,0x0,0x8,0x0
	.DB  0xF,0x0,0x8,0x0,0x0,0x0,0xF,0x0
	.DB  0xF,0x0,0x8,0x0,0x0,0x0,0xF,0x0
	.DB  0x8,0x0
_0x2D:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x8,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0xD,0x0,0xD,0x0,0xD,0x0
	.DB  0xD,0x0,0xD,0x0,0xF,0x0,0xD,0x0
	.DB  0x8,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0x8,0x0,0xD,0x0,0xD,0x0
	.DB  0xD,0x0,0xD,0x0,0xD,0x0,0xF,0x0
	.DB  0xF,0x0,0xD,0x0,0x8,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0x8,0x0,0x8,0x0,0xD,0x0
	.DB  0xD,0x0,0xD,0x0,0xD,0x0,0xD,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xD,0x0
	.DB  0x8,0x0,0x0,0x0,0x0,0x0,0x8,0x0
	.DB  0x8,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0xD,0x0,0xD,0x0,0xD,0x0,0xD,0x0
	.DB  0xD,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xD,0x0,0x8,0x0,0x0,0x0
	.DB  0x8,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0xD,0x0,0xD,0x0,0xD,0x0
	.DB  0xD,0x0,0xD,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xD,0x0
	.DB  0x8,0x0,0x0,0x0
_0x34:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x0
	.DB  0xE,0x0,0x8,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x0
	.DB  0xE,0x0,0x8,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x0
	.DB  0xE,0x0,0x8,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x0
	.DB  0xE,0x0,0x8,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xE,0x0,0x8,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x3,0x0
_0x3B:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x2,0x0,0x4,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x1,0x0,0x8,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x8,0x0,0x1,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0
	.DB  0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0x8,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x4,0x0,0x1,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1,0x0,0x4,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x8,0x0,0x0,0x0,0x0,0x0,0x8,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x4,0x0,0x1,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x0,0x4,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x4,0x0
	.DB  0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x1,0x0,0x4,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x8,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x4,0x0,0x1,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x2,0x0
_0x42:
	.DB  0x0,0x0,0xE,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0xC,0x0
	.DB  0xE,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0x3,0x0,0x3,0x0,0xB,0x0
	.DB  0xB,0x0,0xF,0x0,0x0,0x0,0x2,0x0
	.DB  0x3,0x0,0x3,0x0,0x3,0x0,0x3,0x0
	.DB  0x3,0x0,0x3,0x0,0x3,0x0,0x3,0x0
	.DB  0x3,0x0,0x3,0x0,0x3,0x0,0xB,0x0
	.DB  0xB,0x0,0xB,0x0,0xB,0x0,0xB,0x0
	.DB  0xB,0x0,0xF,0x0,0x8,0x0,0x8,0x0
	.DB  0xE,0x0,0xF,0x0,0xF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0xC,0x0,0xE,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xE,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x8,0x0,0xC,0x0,0xE,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0x0,0x0,0x8,0x0,0x8,0x0,0xE,0x0
	.DB  0xF,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0x8,0x0,0x8,0x0,0x8,0x0
	.DB  0x8,0x0,0x8,0x0,0xE,0x0,0xF,0x0
	.DB  0xF,0x0
_0x49:
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x8,0x0
	.DB  0x5,0x0,0x2,0x0,0x8,0x0,0x5,0x0
	.DB  0x2,0x0,0x8,0x0,0x5,0x0,0x2,0x0
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x8,0x0
	.DB  0x5,0x0,0x2,0x0,0x8,0x0,0x5,0x0
	.DB  0x2,0x0,0x8,0x0,0x5,0x0,0x2,0x0
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x8,0x0
	.DB  0x5,0x0,0x2,0x0
_0x50:
	.DB  0x1,0x0,0x6,0x0,0x8,0x0,0x0,0x0
	.DB  0x0,0x0,0xC,0x0,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x8,0x0,0x5,0x0,0x2,0x0,0x2,0x0
	.DB  0x5,0x0,0x8,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x0,0x5,0x0
	.DB  0x2,0x0
_0x57:
	.DB  0x0,0x0,0x1,0x0,0x7,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0x0,0x0,0xC,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0
	.DB  0xD,0x0,0xF,0x0,0x0,0x0,0x2,0x0
	.DB  0x7,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0
	.DB  0xD,0x0,0xF,0x0
_0x5E:
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xD,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xA,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0x7,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xD,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xA,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0x7,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xD,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xA,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0x7,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xD,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xA,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0x7,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xD,0x0,0xF,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xA,0x0,0xF,0x0,0xF,0x0
	.DB  0xF,0x0,0xF,0x0,0x7,0x0
_0x63:
	.DB  0x90,0x1,0x5,0x0,0xE8,0x3

__GLOBAL_INI_TBL:
	.DW  0x06
	.DW  0x06
	.DW  _0x63*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : zvezda
;Version : luchshaay
;Date    : 12.12.2018
;Author  : Serzh
;Company :
;Comments:
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;/*      Danko,   .
;https://radiokot.ru/forum/viewtopic.php?f=57&t=21235   */
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;
;unsigned char digit_out[5], //   (  0  4 a)
;                   cur_dig; // .  ()
;unsigned int f=400,    //  
;             h=5,      //   
;             z=1000;   // ms    
;
;
;static flash unsigned char digits[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
;
;
;
;
;
;
;// ---------------- Timer 2 overflow interrupt service routine -----------------------------
;
;
;interrupt [TIM2_OVF] void timer2_ovf_isr(void){
; 0000 0031 interrupt [5] void timer2_ovf_isr(void){

	.CSEG
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0032 
; 0000 0033      PORTC&=0b00000000;                  //   ( - off)
	IN   R30,0x15
	ANDI R30,LOW(0x0)
	OUT  0x15,R30
; 0000 0034 
; 0000 0035      PORTD=~digits[digit_out[cur_dig]];
	MOV  R30,R5
	LDI  R31,0
	SUBI R30,LOW(-_digit_out)
	SBCI R31,HIGH(-_digit_out)
	LD   R30,Z
	LDI  R31,0
	SUBI R30,LOW(-_digits_G000*2)
	SBCI R31,HIGH(-_digits_G000*2)
	LPM  R30,Z
	COM  R30
	OUT  0x12,R30
; 0000 0036 
; 0000 0037      PORTC |= (1<<cur_dig);            //    (  - on)
	IN   R1,21
	MOV  R30,R5
	LDI  R26,LOW(1)
	RCALL __LSLB12
	OR   R30,R1
	OUT  0x15,R30
; 0000 0038 
; 0000 0039          cur_dig++; if (cur_dig >= 5) {
	INC  R5
	LDI  R30,LOW(5)
	CP   R5,R30
	BRLO _0x3
; 0000 003A         cur_dig = 0;
	CLR  R5
; 0000 003B 
; 0000 003C     }
; 0000 003D 
; 0000 003E }// ----------------------------------------------------------------------------------------
_0x3:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// ----------------------------------------------------------------------------------------
;
;void view_pauza(void) {
; 0000 0042 void view_pauza(void) {
_view_pauza:
; 0000 0043     digit_out[0] = 15;
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x0
; 0000 0044     digit_out[1] = 15;
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x1
; 0000 0045     digit_out[2] = 15;
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x2
; 0000 0046     digit_out[3] = 15;
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x3
; 0000 0047     digit_out[4] = 15;
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x4
; 0000 0048        delay_ms(z);
	ST   -Y,R11
	ST   -Y,R10
	RCALL _delay_ms
; 0000 0049        }
	RET
;// ----------------------------------------------------------------------------------------
;
;void view_flasher(void) {
; 0000 004C void view_flasher(void) {
_view_flasher:
; 0000 004D      int i,j;
; 0000 004E    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x5:
	RCALL SUBOPT_0x6
	BRSH _0x6
; 0000 004F 
; 0000 0050    for (i =0; i<9;++i){
	RCALL SUBOPT_0x7
_0x8:
	__CPWRN 16,17,9
	BRGE _0x9
; 0000 0051 
; 0000 0052      unsigned int A[] = {8,5,2,5,8,5,2,5,8};
; 0000 0053      unsigned int B[] = {8,5,2,5,8,5,2,5,8};
; 0000 0054      unsigned int C[] = {8,5,2,5,8,5,2,5,8};
; 0000 0055      unsigned int D[] = {8,5,2,5,8,5,2,5,8};
; 0000 0056      unsigned int E[] = {8,5,2,5,8,5,2,5,8};
; 0000 0057 
; 0000 0058 
; 0000 0059     digit_out[0] = A[i];
	RCALL SUBOPT_0x8
	LDI  R30,LOW(_0xA*2)
	LDI  R31,HIGH(_0xA*2)
	RCALL __INITLOCB
;	A -> Y+72
;	B -> Y+54
;	C -> Y+36
;	D -> Y+18
;	E -> Y+0
	RCALL SUBOPT_0x9
; 0000 005A     digit_out[1] = B[i];
; 0000 005B     digit_out[2] = C[i];
	RCALL SUBOPT_0xA
; 0000 005C     digit_out[3] = D[i];
	RCALL SUBOPT_0xB
; 0000 005D     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 005E 
; 0000 005F         delay_ms(f);
	RCALL SUBOPT_0xD
; 0000 0060      }
	RCALL SUBOPT_0xE
	RJMP _0x8
_0x9:
; 0000 0061 
; 0000 0062   }
	RCALL SUBOPT_0xF
	RJMP _0x5
_0x6:
; 0000 0063   view_pauza();
	RCALL _view_pauza
; 0000 0064 }
	RJMP _0x2000001
;
;// ----------------------------------------------------------------------------------------
;
;void view_flasher_1(void) {
; 0000 0068 void view_flasher_1(void) {
_view_flasher_1:
; 0000 0069      int i,j;
; 0000 006A    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0xC:
	RCALL SUBOPT_0x6
	BRSH _0xD
; 0000 006B 
; 0000 006C    for (i =0; i<9;++i){
	RCALL SUBOPT_0x7
_0xF:
	__CPWRN 16,17,9
	BRGE _0x10
; 0000 006D 
; 0000 006E      unsigned int A[] = {8,1,2,4,8,4,2,1,8};
; 0000 006F      unsigned int B[] = {8,1,2,4,8,4,2,1,8};
; 0000 0070      unsigned int C[] = {8,1,2,4,8,4,2,1,8};
; 0000 0071      unsigned int D[] = {8,1,2,4,8,4,2,1,8};
; 0000 0072      unsigned int E[] = {8,1,2,4,8,4,2,1,8};
; 0000 0073 
; 0000 0074 
; 0000 0075     digit_out[0] = A[i];
	RCALL SUBOPT_0x8
	LDI  R30,LOW(_0x11*2)
	LDI  R31,HIGH(_0x11*2)
	RCALL __INITLOCB
;	A -> Y+72
;	B -> Y+54
;	C -> Y+36
;	D -> Y+18
;	E -> Y+0
	RCALL SUBOPT_0x9
; 0000 0076     digit_out[1] = B[i];
; 0000 0077     digit_out[2] = C[i];
	RCALL SUBOPT_0xA
; 0000 0078     digit_out[3] = D[i];
	RCALL SUBOPT_0xB
; 0000 0079     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 007A 
; 0000 007B         delay_ms(f);
	RCALL SUBOPT_0xD
; 0000 007C     }
	RCALL SUBOPT_0xE
	RJMP _0xF
_0x10:
; 0000 007D 
; 0000 007E  }
	RCALL SUBOPT_0xF
	RJMP _0xC
_0xD:
; 0000 007F      view_pauza();
	RCALL _view_pauza
; 0000 0080    }
	RJMP _0x2000001
;// ----------------------------------------------------------------------------------------
;
;void view_flasher_2(void) {
; 0000 0083 void view_flasher_2(void) {
_view_flasher_2:
; 0000 0084      int i,j;
; 0000 0085    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x13:
	RCALL SUBOPT_0x6
	BRSH _0x14
; 0000 0086 
; 0000 0087    for (i =0; i<12;++i){
	RCALL SUBOPT_0x7
_0x16:
	__CPWRN 16,17,12
	BRGE _0x17
; 0000 0088 
; 0000 0089      unsigned int A[] = {15,15,15,15,15,0,0,0,0,0,15,0};
; 0000 008A      unsigned int B[] = {0,15,15,15,15,15,0,0,0,0,15,0};
; 0000 008B      unsigned int C[] = {0,0,15,15,15,15,15,0,0,0,15,0};
; 0000 008C      unsigned int D[] = {0,0,0,15,15,15,15,15,0,0,15,0};
; 0000 008D      unsigned int E[] = {0,0,0,0,15,15,15,15,15,0,15,0};
; 0000 008E 
; 0000 008F 
; 0000 0090     digit_out[0] = A[i];
	SBIW R28,63
	SBIW R28,57
	LDI  R24,120
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x18*2)
	LDI  R31,HIGH(_0x18*2)
	RCALL __INITLOCB
;	A -> Y+96
;	B -> Y+72
;	C -> Y+48
;	D -> Y+24
;	E -> Y+0
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(96))
	SBCI R27,HIGH(-(96))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
; 0000 0091     digit_out[1] = B[i];
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1
; 0000 0092     digit_out[2] = C[i];
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x2
; 0000 0093     digit_out[3] = D[i];
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x3
; 0000 0094     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 0095 
; 0000 0096         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 0097     }
	ADIW R28,63
	ADIW R28,57
	RCALL SUBOPT_0xE
	RJMP _0x16
_0x17:
; 0000 0098  }
	RCALL SUBOPT_0xF
	RJMP _0x13
_0x14:
; 0000 0099        view_pauza();
	RCALL _view_pauza
; 0000 009A    }
	RJMP _0x2000001
;
;   // ----------------------------------------------------------------------------------------
;
;void view_flasher_3(void) {
; 0000 009E void view_flasher_3(void) {
_view_flasher_3:
; 0000 009F      int i,j;
; 0000 00A0    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x1A:
	RCALL SUBOPT_0x6
	BRSH _0x1B
; 0000 00A1 
; 0000 00A2    for (i =0; i<23;++i){
	RCALL SUBOPT_0x7
_0x1D:
	__CPWRN 16,17,23
	BRGE _0x1E
; 0000 00A3 
; 0000 00A4      unsigned int A[] = {0,0,8,12,14,15,15,15,15,15 ,15,15,15,15,15,15,14,12, 8,0,0,15,0};
; 0000 00A5      unsigned int B[] = {2,7,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,7,2,15,0};
; 0000 00A6      unsigned int C[] = {0,0,0,1,3,7,15,15,15,15    ,15,15,15,15,15, 7 ,3 ,1 ,0,0,0,15,0};
; 0000 00A7      unsigned int D[] = {0,0,0,0,0,0,0,1,3,7        ,15,7,  3, 1 ,0 ,0 ,0 ,0 ,0,0,0,15,0};
; 0000 00A8      unsigned int E[] = {0,0,0,0,0,0,8,12,14,15     ,15,15,14,12 ,8 ,0 ,0 ,0 ,0,0,0,15,0};
; 0000 00A9 
; 0000 00AA 
; 0000 00AB     digit_out[0] = A[i];
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,41
	LDI  R24,230
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x1F*2)
	LDI  R31,HIGH(_0x1F*2)
	RCALL __INITLOCB
;	A -> Y+184
;	B -> Y+138
;	C -> Y+92
;	D -> Y+46
;	E -> Y+0
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(184))
	SBCI R27,HIGH(-(184))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
; 0000 00AC     digit_out[1] = B[i];
	MOVW R26,R28
	SUBI R26,LOW(-(138))
	SBCI R27,HIGH(-(138))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1
; 0000 00AD     digit_out[2] = C[i];
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(92))
	SBCI R27,HIGH(-(92))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x2
; 0000 00AE     digit_out[3] = D[i];
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,46
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x3
; 0000 00AF     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 00B0 
; 0000 00B1         delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x17
; 0000 00B2     }
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,41
	RCALL SUBOPT_0xE
	RJMP _0x1D
_0x1E:
; 0000 00B3 
; 0000 00B4   }
	RCALL SUBOPT_0xF
	RJMP _0x1A
_0x1B:
; 0000 00B5    view_pauza();
	RCALL _view_pauza
; 0000 00B6 }
	RJMP _0x2000001
;
;   // ----------------------------------------------------------------------------------------
;
;void view_flasher_4(void) {
; 0000 00BA void view_flasher_4(void) {
_view_flasher_4:
; 0000 00BB      int i,j;
; 0000 00BC    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x21:
	RCALL SUBOPT_0x6
	BRSH _0x22
; 0000 00BD 
; 0000 00BE    for (i =0; i<5;++i){
	RCALL SUBOPT_0x7
_0x24:
	__CPWRN 16,17,5
	BRGE _0x25
; 0000 00BF 
; 0000 00C0      unsigned int A[] = {15, 8, 0,15, 8};
; 0000 00C1      unsigned int B[] = { 8,15, 8, 0,15};
; 0000 00C2      unsigned int C[] = {15, 8,15, 8, 0};
; 0000 00C3      unsigned int D[] = { 0,15, 8,15, 8};
; 0000 00C4      unsigned int E[] = { 8, 0,15, 8,15};
; 0000 00C5 
; 0000 00C6 
; 0000 00C7     digit_out[0] = A[i];
	SBIW R28,50
	LDI  R24,50
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x26*2)
	LDI  R31,HIGH(_0x26*2)
	RCALL __INITLOCB
;	A -> Y+40
;	B -> Y+30
;	C -> Y+20
;	D -> Y+10
;	E -> Y+0
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x12
; 0000 00C8     digit_out[1] = B[i];
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1
; 0000 00C9     digit_out[2] = C[i];
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x2
; 0000 00CA     digit_out[3] = D[i];
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x3
; 0000 00CB     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 00CC 
; 0000 00CD         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 00CE     }
	ADIW R28,50
	RCALL SUBOPT_0xE
	RJMP _0x24
_0x25:
; 0000 00CF 
; 0000 00D0   }
	RCALL SUBOPT_0xF
	RJMP _0x21
_0x22:
; 0000 00D1    view_pauza();
	RCALL _view_pauza
; 0000 00D2 }
	RJMP _0x2000001
;
;
;   // ----------------------------------------------------------------------------------------
;
;void view_flasher_5(void) {
; 0000 00D7 void view_flasher_5(void) {
_view_flasher_5:
; 0000 00D8      int i,j;
; 0000 00D9    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x28:
	RCALL SUBOPT_0x6
	BRSH _0x29
; 0000 00DA 
; 0000 00DB    for (i =0; i<18;++i){
	RCALL SUBOPT_0x7
_0x2B:
	__CPWRN 16,17,18
	BRGE _0x2C
; 0000 00DC 
; 0000 00DD      unsigned int A[] = {8,8,8,8,8,13,13,13,13,13,15,15,15,15,15,13,8,0};
; 0000 00DE      unsigned int B[] = {0,8,8,8,8, 8,13,13,13,13,13,15,15,15,15,13,8,0};
; 0000 00DF      unsigned int C[] = {0,0,8,8,8, 8, 8,13,13,13,13,13,15,15,15,13,8,0};
; 0000 00E0      unsigned int D[] = {0,0,0,8,8, 8, 8, 8,13,13,13,13,13,15,15,13,8,0};
; 0000 00E1      unsigned int E[] = {0,0,0,0,8, 8, 8, 8, 8,13,13,13,13,13,15,13,8,0};
; 0000 00E2 
; 0000 00E3 
; 0000 00E4     digit_out[0] = A[i];
	SBIW R28,63
	SBIW R28,63
	SBIW R28,54
	LDI  R24,180
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x2D*2)
	LDI  R31,HIGH(_0x2D*2)
	RCALL __INITLOCB
;	A -> Y+144
;	B -> Y+108
;	C -> Y+72
;	D -> Y+36
;	E -> Y+0
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(144))
	SBCI R27,HIGH(-(144))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
; 0000 00E5     digit_out[1] = B[i];
	MOVW R26,R28
	SUBI R26,LOW(-(108))
	SBCI R27,HIGH(-(108))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1
; 0000 00E6     digit_out[2] = C[i];
	MOVW R30,R16
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x2
; 0000 00E7     digit_out[3] = D[i];
	MOVW R30,R16
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x3
; 0000 00E8     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 00E9 
; 0000 00EA         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 00EB     }
	ADIW R28,63
	ADIW R28,63
	ADIW R28,54
	RCALL SUBOPT_0xE
	RJMP _0x2B
_0x2C:
; 0000 00EC 
; 0000 00ED   }
	RCALL SUBOPT_0xF
	RJMP _0x28
_0x29:
; 0000 00EE    view_pauza();
	RCALL _view_pauza
; 0000 00EF }
	RJMP _0x2000001
;
;
;   // ----------------------------------------------------------------------------------------
;
;void view_flasher_6(void) {
; 0000 00F4 void view_flasher_6(void) {
_view_flasher_6:
; 0000 00F5      int i,j;
; 0000 00F6    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x2F:
	RCALL SUBOPT_0x6
	BRSH _0x30
; 0000 00F7 
; 0000 00F8    for (i =0; i<10;++i){
	RCALL SUBOPT_0x7
_0x32:
	__CPWRN 16,17,10
	BRGE _0x33
; 0000 00F9 
; 0000 00FA      unsigned int A[] = {14,8,0,0,0,0,0,0,0,3};
; 0000 00FB      unsigned int B[] = {0,3,14,8,0,0,0,0,0,0};
; 0000 00FC      unsigned int C[] = {0,0,0,3,14,8,0,0,0,0};
; 0000 00FD      unsigned int D[] = {0,0,0,0,0,3,14,8,0,0};
; 0000 00FE      unsigned int E[] = {0,0,0,0,0,0,0,3,14,8};
; 0000 00FF 
; 0000 0100 
; 0000 0101     digit_out[0] = A[i];
	SBIW R28,63
	SBIW R28,37
	LDI  R24,100
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x34*2)
	LDI  R31,HIGH(_0x34*2)
	RCALL __INITLOCB
;	A -> Y+80
;	B -> Y+60
;	C -> Y+40
;	D -> Y+20
;	E -> Y+0
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(80))
	SBCI R27,HIGH(-(80))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
; 0000 0102     digit_out[1] = B[i];
	MOVW R26,R28
	ADIW R26,60
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1
; 0000 0103     digit_out[2] = C[i];
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x2
; 0000 0104     digit_out[3] = D[i];
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x3
; 0000 0105     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 0106 
; 0000 0107         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 0108     }
	ADIW R28,63
	ADIW R28,37
	RCALL SUBOPT_0xE
	RJMP _0x32
_0x33:
; 0000 0109 
; 0000 010A   }
	RCALL SUBOPT_0xF
	RJMP _0x2F
_0x30:
; 0000 010B    view_pauza();
	RCALL _view_pauza
; 0000 010C }
	RJMP _0x2000001
;
;  // ----------------------------------------------------------------------------------------
;void view_flasher_7(void) {
; 0000 010F void view_flasher_7(void) {
_view_flasher_7:
; 0000 0110      int i,j;
; 0000 0111    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x36:
	RCALL SUBOPT_0x6
	BRSH _0x37
; 0000 0112 
; 0000 0113    for (i =0; i<40;++i){
	RCALL SUBOPT_0x7
_0x39:
	__CPWRN 16,17,40
	BRGE _0x3A
; 0000 0114 
; 0000 0115      unsigned int A[] = {2,0,0,0,0,0,1,4,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,4,1,0,0,0,0,2};
; 0000 0116      unsigned int B[] = {0,2,0,0,0,0,0,0,1,4,0,0,0,0,0,0,0,8,0,0,0,0,8,0,0,0,0,0,0,0,4,1,0,0,0,0,0,2,0};
; 0000 0117      unsigned int C[] = {0,0,2,0,0,0,0,0,0,0,1,4,0,0,0,0,0,0,8,0,0,8,0,0,0,0,0,0,4,1,0,0,0,0,0,0,2,0,0};
; 0000 0118      unsigned int D[] = {0,0,0,2,0,0,0,0,0,0,0,0,1,4,0,0,0,0,0,8,8,0,0,0,0,0,4,1,0,0,0,0,0,0,0,2,0,0,0};
; 0000 0119      unsigned int E[] = {0,0,0,0,2,4,0,0,0,0,0,0,0,0,1,8,0,0,0,0,0,0,0,0,8,1,0,0,0,0,0,0,0,0,2,0,0,0,0};
; 0000 011A 
; 0000 011B 
; 0000 011C     digit_out[0] = A[i];
	SBIW R28,63
	SBIW R28,63
	SBIW R28,8
	SUBI R29,1
	__GETWRN 24,25,390
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x3B*2)
	LDI  R31,HIGH(_0x3B*2)
	RCALL __INITLOCW
;	A -> Y+312
;	B -> Y+234
;	C -> Y+156
;	D -> Y+78
;	E -> Y+0
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(312))
	SBCI R27,HIGH(-(312))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
; 0000 011D     digit_out[1] = B[i];
	MOVW R26,R28
	SUBI R26,LOW(-(234))
	SBCI R27,HIGH(-(234))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1
; 0000 011E     digit_out[2] = C[i];
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(156))
	SBCI R27,HIGH(-(156))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x2
; 0000 011F     digit_out[3] = D[i];
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(78))
	SBCI R27,HIGH(-(78))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x3
; 0000 0120     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 0121 
; 0000 0122         delay_ms(80);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	RCALL SUBOPT_0x17
; 0000 0123     }
	ADIW R28,63
	ADIW R28,63
	ADIW R28,8
	SUBI R29,-1
	RCALL SUBOPT_0xE
	RJMP _0x39
_0x3A:
; 0000 0124 
; 0000 0125   }
	RCALL SUBOPT_0xF
	RJMP _0x36
_0x37:
; 0000 0126    view_pauza();
	RCALL _view_pauza
; 0000 0127 }
	RJMP _0x2000001
;
;  // ----------------------------------------------------------------------------------------
;
;void view_flasher_8(void) {
; 0000 012B void view_flasher_8(void) {
_view_flasher_8:
; 0000 012C      int i,j;
; 0000 012D    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x3D:
	RCALL SUBOPT_0x6
	BRSH _0x3E
; 0000 012E 
; 0000 012F    for (i =0; i<25;++i){
	RCALL SUBOPT_0x7
_0x40:
	__CPWRN 16,17,25
	BRGE _0x41
; 0000 0130 
; 0000 0131      unsigned int A[] = {0,8,8,14,15,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,14,15,15};
; 0000 0132      unsigned int B[] = {14,15,15,15,15,0,0,0,0,8,12,14,15,15,15,15,15,15,15,15,15,15,15,15,15};
; 0000 0133      unsigned int C[] = {8,8,14,15,15,0,0,0,8,8,8,8,8,8,8,8,8,8,8,12,14,15,15,15,15};
; 0000 0134      unsigned int D[] = {3,3,11,11,15,0,2,3,3,3,3,3,3,3,3,3,3,3,11,11,11,11,11,11,15};
; 0000 0135      unsigned int E[] = {0,14,15,15,15,0,0,0,0,0,0,0,0,0,8,12,14,15,15,15,15,15,15,15,15};
; 0000 0136 
; 0000 0137 
; 0000 0138     digit_out[0] = A[i];
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,61
	LDI  R24,250
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x42*2)
	LDI  R31,HIGH(_0x42*2)
	RCALL __INITLOCB
;	A -> Y+200
;	B -> Y+150
;	C -> Y+100
;	D -> Y+50
;	E -> Y+0
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(200))
	SBCI R27,HIGH(-(200))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
; 0000 0139     digit_out[1] = B[i];
	MOVW R26,R28
	SUBI R26,LOW(-(150))
	SBCI R27,HIGH(-(150))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1
; 0000 013A     digit_out[2] = C[i];
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(100))
	SBCI R27,HIGH(-(100))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x2
; 0000 013B     digit_out[3] = D[i];
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,50
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x3
; 0000 013C     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 013D 
; 0000 013E         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 013F     }
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,61
	RCALL SUBOPT_0xE
	RJMP _0x40
_0x41:
; 0000 0140 
; 0000 0141   }
	RCALL SUBOPT_0xF
	RJMP _0x3D
_0x3E:
; 0000 0142    view_pauza();
	RCALL _view_pauza
; 0000 0143 }
	RJMP _0x2000001
;
;  // ----------------------------------------------------------------------------------------
;
;void view_flasher_9(void) {
; 0000 0147 void view_flasher_9(void) {
_view_flasher_9:
; 0000 0148      int i,j;
; 0000 0149    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x44:
	RCALL SUBOPT_0x6
	BRSH _0x45
; 0000 014A 
; 0000 014B    for (i =0; i<6;++i){
	RCALL SUBOPT_0x7
_0x47:
	__CPWRN 16,17,6
	BRGE _0x48
; 0000 014C 
; 0000 014D      unsigned int A[] = {8,5,2,8,5,2};
; 0000 014E      unsigned int B[] = {8,5,2,8,5,2};
; 0000 014F      unsigned int C[] = {8,5,2,8,5,2};
; 0000 0150      unsigned int D[] = {8,5,2,8,5,2};
; 0000 0151      unsigned int E[] = {8,5,2,8,5,2};
; 0000 0152 
; 0000 0153 
; 0000 0154     digit_out[0] = A[i];
	SBIW R28,60
	LDI  R24,60
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x49*2)
	LDI  R31,HIGH(_0x49*2)
	RCALL __INITLOCB
;	A -> Y+48
;	B -> Y+36
;	C -> Y+24
;	D -> Y+12
;	E -> Y+0
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x12
; 0000 0155     digit_out[1] = B[i];
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1
; 0000 0156     digit_out[2] = C[i];
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x2
; 0000 0157     digit_out[3] = D[i];
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x3
; 0000 0158     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 0159 
; 0000 015A         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 015B     }
	ADIW R28,60
	RCALL SUBOPT_0xE
	RJMP _0x47
_0x48:
; 0000 015C 
; 0000 015D   }
	RCALL SUBOPT_0xF
	RJMP _0x44
_0x45:
; 0000 015E    view_pauza();
	RCALL _view_pauza
; 0000 015F }
	RJMP _0x2000001
;
;  // ----------------------------------------------------------------------------------------
;
;void view_flasher_10(void) {
; 0000 0163 void view_flasher_10(void) {
_view_flasher_10:
; 0000 0164      int i,j;
; 0000 0165    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x4B:
	RCALL SUBOPT_0x6
	BRSH _0x4C
; 0000 0166 
; 0000 0167    for (i =0; i<5;++i){
	RCALL SUBOPT_0x7
_0x4E:
	__CPWRN 16,17,5
	BRGE _0x4F
; 0000 0168 
; 0000 0169      unsigned int A[] = {0, 0,8,5,2};
; 0000 016A      unsigned int B[] = {2, 5,8,0,0};
; 0000 016B      unsigned int C[] = {0, 0,8,5,2};
; 0000 016C      unsigned int D[] = {12,3,0,0,0};
; 0000 016D      unsigned int E[] = {1, 6,8,0,0};
; 0000 016E 
; 0000 016F 
; 0000 0170     digit_out[0] = A[i];
	SBIW R28,50
	LDI  R24,50
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x50*2)
	LDI  R31,HIGH(_0x50*2)
	RCALL __INITLOCB
;	A -> Y+40
;	B -> Y+30
;	C -> Y+20
;	D -> Y+10
;	E -> Y+0
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x12
; 0000 0171     digit_out[1] = B[i];
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1
; 0000 0172     digit_out[2] = C[i];
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x2
; 0000 0173     digit_out[3] = D[i];
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x3
; 0000 0174     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 0175 
; 0000 0176         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 0177     }
	ADIW R28,50
	RCALL SUBOPT_0xE
	RJMP _0x4E
_0x4F:
; 0000 0178 
; 0000 0179   }
	RCALL SUBOPT_0xF
	RJMP _0x4B
_0x4C:
; 0000 017A    view_pauza();
	RCALL _view_pauza
; 0000 017B }
	RJMP _0x2000001
;
;  // ----------------------------------------------------------------------------------------
;
;void view_flasher_11(void) {
; 0000 017F void view_flasher_11(void) {
_view_flasher_11:
; 0000 0180      int i,j;
; 0000 0181    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x52:
	RCALL SUBOPT_0x6
	BRSH _0x53
; 0000 0182 
; 0000 0183    for (i =0; i<6;++i){
	RCALL SUBOPT_0x7
_0x55:
	__CPWRN 16,17,6
	BRGE _0x56
; 0000 0184 
; 0000 0185      unsigned int A[] = {0, 0,  0, 8,13,15};
; 0000 0186      unsigned int B[] = {0, 2,  7,15,15,15};
; 0000 0187      unsigned int C[] = {0, 0,  0, 8,13,15};
; 0000 0188      unsigned int D[] = {0,12,15,15,15,15};
; 0000 0189      unsigned int E[] = {0, 1,  7,15,15,15};
; 0000 018A 
; 0000 018B 
; 0000 018C     digit_out[0] = A[i];
	SBIW R28,60
	LDI  R24,60
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x57*2)
	LDI  R31,HIGH(_0x57*2)
	RCALL __INITLOCB
;	A -> Y+48
;	B -> Y+36
;	C -> Y+24
;	D -> Y+12
;	E -> Y+0
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x12
; 0000 018D     digit_out[1] = B[i];
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1
; 0000 018E     digit_out[2] = C[i];
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x2
; 0000 018F     digit_out[3] = D[i];
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x3
; 0000 0190     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 0191 
; 0000 0192         delay_ms(f);
	RCALL SUBOPT_0x16
; 0000 0193     }
	ADIW R28,60
	RCALL SUBOPT_0xE
	RJMP _0x55
_0x56:
; 0000 0194 
; 0000 0195   }
	RCALL SUBOPT_0xF
	RJMP _0x52
_0x53:
; 0000 0196    view_pauza();
	RCALL _view_pauza
; 0000 0197 }
	RJMP _0x2000001
;
;  // ----------------------------------------------------------------------------------------
;
;void view_flasher_12(void) {
; 0000 019B void view_flasher_12(void) {
_view_flasher_12:
; 0000 019C      int i,j;
; 0000 019D    for (j =0; j<h;++j){
	RCALL SUBOPT_0x5
;	i -> R16,R17
;	j -> R18,R19
_0x59:
	RCALL SUBOPT_0x6
	BRSH _0x5A
; 0000 019E 
; 0000 019F    for (i =0; i<15;++i){
	RCALL SUBOPT_0x7
_0x5C:
	__CPWRN 16,17,15
	BRGE _0x5D
; 0000 01A0 
; 0000 01A1      unsigned int A[] = {15,15,15,15,13,15,15,15,15,10,15,15,15,15, 7};
; 0000 01A2      unsigned int B[] = {13,15,15,15,15,10,15,15,15,15, 7,15,15,15,15};
; 0000 01A3      unsigned int C[] = {15,13,15,15,15,15,10,15,15,15,15, 7,15,15,15};
; 0000 01A4      unsigned int D[] = {15,15,13,15,15,15,15,10,15,15,15,15, 7,15,15};
; 0000 01A5      unsigned int E[] = {15,15,15,13,15,15,15,15,10,15,15,15,15, 7,15};
; 0000 01A6 
; 0000 01A7 
; 0000 01A8     digit_out[0] = A[i];
	SBIW R28,63
	SBIW R28,63
	SBIW R28,24
	LDI  R24,150
	RCALL SUBOPT_0x10
	LDI  R30,LOW(_0x5E*2)
	LDI  R31,HIGH(_0x5E*2)
	RCALL __INITLOCB
;	A -> Y+120
;	B -> Y+90
;	C -> Y+60
;	D -> Y+30
;	E -> Y+0
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(120))
	SBCI R27,HIGH(-(120))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
; 0000 01A9     digit_out[1] = B[i];
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1
; 0000 01AA     digit_out[2] = C[i];
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,60
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x2
; 0000 01AB     digit_out[3] = D[i];
	MOVW R30,R16
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x3
; 0000 01AC     digit_out[4] = E[i];
	RCALL SUBOPT_0xC
; 0000 01AD 
; 0000 01AE         delay_ms(150);
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	RCALL SUBOPT_0x17
; 0000 01AF     }
	ADIW R28,63
	ADIW R28,63
	ADIW R28,24
	RCALL SUBOPT_0xE
	RJMP _0x5C
_0x5D:
; 0000 01B0 
; 0000 01B1   }
	RCALL SUBOPT_0xF
	RJMP _0x59
_0x5A:
; 0000 01B2 
; 0000 01B3 }
_0x2000001:
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;
;//===================================== main ==============================================
;
;// 
;void main(void){
; 0000 01B8 void main(void){
_main:
; 0000 01B9 
; 0000 01BA    digit_out[0]=0;   //  
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x0
; 0000 01BB    digit_out[1]=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1
; 0000 01BC    digit_out[2]=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x2
; 0000 01BD    digit_out[3]=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x3
; 0000 01BE    digit_out[4]=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x4
; 0000 01BF 
; 0000 01C0 
; 0000 01C1 // 
; 0000 01C2 PORTB=0b00000000;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 01C3  DDRB=0b00000000;
	OUT  0x17,R30
; 0000 01C4 PORTC=0b00000000;   //  4    1
	OUT  0x15,R30
; 0000 01C5  DDRC=0b00011111;   //  4    
	LDI  R30,LOW(31)
	OUT  0x14,R30
; 0000 01C6 PORTD=0b00000000;  // D      0
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 01C7  DDRD=0b00001111;  // D    
	LDI  R30,LOW(15)
	OUT  0x11,R30
; 0000 01C8 
; 0000 01C9 TCCR2=0x04;
	LDI  R30,LOW(4)
	OUT  0x25,R30
; 0000 01CA TIMSK=0b01000000;
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0000 01CB //              0b11000001
; 0000 01CC //                ||   | |
; 0000 01CD //                ||   | Timer0
; 0000 01CE //                ||   Timer1
; 0000 01CF //                |Timer2
; 0000 01D0 //
; 0000 01D1 #asm("sei")   //   
	sei
; 0000 01D2 
; 0000 01D3 // --------------------------------   ------------------------------------------
; 0000 01D4  while (1) {
_0x5F:
; 0000 01D5 
; 0000 01D6 
; 0000 01D7   view_flasher();
	RCALL _view_flasher
; 0000 01D8   view_flasher_1();
	RCALL _view_flasher_1
; 0000 01D9   view_flasher_2();
	RCALL _view_flasher_2
; 0000 01DA   view_flasher_3();
	RCALL _view_flasher_3
; 0000 01DB   view_flasher_4();
	RCALL _view_flasher_4
; 0000 01DC   view_flasher_5();
	RCALL _view_flasher_5
; 0000 01DD   view_flasher_6();
	RCALL _view_flasher_6
; 0000 01DE   view_flasher_7();
	RCALL _view_flasher_7
; 0000 01DF   view_flasher_8();
	RCALL _view_flasher_8
; 0000 01E0   view_flasher_9();
	RCALL _view_flasher_9
; 0000 01E1   view_flasher_10();
	RCALL _view_flasher_10
; 0000 01E2   view_flasher_11();
	RCALL _view_flasher_11
; 0000 01E3   view_flasher_12();
	RCALL _view_flasher_12
; 0000 01E4 
; 0000 01E5  }; // -----------------------------   (end) ------------------------------------
	RJMP _0x5F
; 0000 01E6 
; 0000 01E7 } // =================================== end main ==========================================
_0x62:
	RJMP _0x62
;
;//
;// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- The End -=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;//
;
;
;
;
;
;
;
;
;

	.DSEG
_digit_out:
	.BYTE 0x5

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x0:
	STS  _digit_out,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1:
	__PUTB1MN _digit_out,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2:
	__PUTB1MN _digit_out,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3:
	__PUTB1MN _digit_out,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x4:
	__PUTB1MN _digit_out,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x5:
	RCALL __SAVELOCR4
	__GETWRN 18,19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x6:
	__CPWRR 18,19,8,9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	__GETWRN 16,17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	SBIW R28,63
	SBIW R28,27
	LDI  R24,90
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x9:
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(72))
	SBCI R27,HIGH(-(72))
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RCALL SUBOPT_0x0
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,54
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xA:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,36
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xB:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,18
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:94 WORDS
SUBOPT_0xC:
	MOVW R30,R16
	MOVW R26,R28
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD:
	ST   -Y,R7
	ST   -Y,R6
	RCALL _delay_ms
	ADIW R28,63
	ADIW R28,27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xE:
	__ADDWRN 16,17,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xF:
	__ADDWRN 18,19,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 44 TIMES, CODE SIZE REDUCTION:170 WORDS
SUBOPT_0x11:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x12:
	RCALL SUBOPT_0x0
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	MOVW R26,R28
	SUBI R26,LOW(-(72))
	SBCI R27,HIGH(-(72))
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x14:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,48
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x15:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,24
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x16:
	ST   -Y,R7
	ST   -Y,R6
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x18:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,40
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	MOVW R26,R28
	ADIW R26,30
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,20
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,10
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	MOVW R26,R28
	ADIW R26,36
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,12
	RJMP SUBOPT_0x11


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
	CLR  R25
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
